// -------------------------------------------------------------
// pNX}bsO
// 
// Copyright (c) 2003 IMAGIRE Takashi. All rights reserved.
// -------------------------------------------------------------

// -------------------------------------------------------------
// O[oϐ
// -------------------------------------------------------------

float4x4 mWVP;		// Wϊ̍s

float4 vLightDir;	// Cg̕
float4 vColor;		// CgbV̐F
float3 vEyePos;		// J̈ʒui[JWnj

// -------------------------------------------------------------
// eNX`
// -------------------------------------------------------------
// ͗l̃eNX`
texture DecaleTex;
sampler DecaleSamp = sampler_state
{
    Texture = <DecaleTex>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
// -------------------------------------------------------------
// @}bv
texture NormalMap;
sampler NormalSamp = sampler_state
{
    Texture = <NormalMap>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Wrap;
    AddressV = Wrap;
};

// -------------------------------------------------------------
// }bv
texture HeightMap;
sampler HeightSamp = sampler_state
{
    Texture = <HeightMap>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Wrap;
    AddressV = Wrap;
};

// -------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// -------------------------------------------------------------
struct VS_OUTPUT
{
    float4 Pos			: POSITION;
    float4 Color		: COLOR0;		// _F
    float2 Tex			: TEXCOORD0;	// fJ[eNX`W
    float3 L			: TEXCOORD1;	// CgxNg
    float3 E			: TEXCOORD2;	// xNg
};
// -------------------------------------------------------------
// V[̕`
// -------------------------------------------------------------
VS_OUTPUT VS(
      float4 Pos      : POSITION,          // [JʒuW
      float3 Normal   : NORMAL,            // @xNg
      float3 Tangent  : TANGENT0,          // ڃxNg
      float2 Texcoord : TEXCOORD0          // @xNg
){
	VS_OUTPUT Out = (VS_OUTPUT)0;        // o̓f[^
	
	// Wϊ
	Out.Pos = mul(Pos, mWVP);
	
	// bV̐F
	Out.Color = vColor;
	
	// fJ[p̃eNX`W
	Out.Tex = Texcoord;

	// Wn̕ϊ
	float3 N = Normal;
	float3 T = Tangent;
	float3 B = cross(N,T);

	// ʔ˗p̃xNg
	float3 E = vEyePos - Pos.xyz;	// xNg
	Out.E.x = dot(E,T);
	Out.E.y = dot(E,B);
	Out.E.z = dot(E,N);

	float3 L = -vLightDir.xyz;		// CgxNg
	Out.L.x = dot(L,T);
	Out.L.y = dot(L,B);
	Out.L.z = dot(L,N);
	
	return Out;
}
// -------------------------------------------------------------
float4 PS( VS_OUTPUT In) : COLOR
{   
	float3 L = normalize(In.L);						// CgxNg
	float3 E = normalize(In.E);						// xNg

	float h = tex2D( HeightSamp, In.Tex );// }bṽTvO
	
	float2 Tex = In.Tex + 0.03 * h * E.xy;
	
	float3 N = 2.0f*tex2D( NormalSamp, Tex ).xyz-1.0;// @}bv̖@
	float3 R = reflect(-E, N);		// ˃xNg
	float amb = -vLightDir.w;						// ̋
	
    return In.Color * tex2D( DecaleSamp, Tex )	// gUƊɂ́A
			   * (max(0, dot(N, L))+amb)			// _FƃeNX`̐F
			 + 0.3f * pow(max(0,dot(R, L)), 8);		// Phong ʔˌ
}

// -------------------------------------------------------------
float4 PS_BUMP( VS_OUTPUT In) : COLOR
{   
	float3 L = normalize(In.L);						// CgxNg
	float3 E = normalize(In.E);						// xNg

	float h = tex2D( HeightSamp, In.Tex );// }bṽTvO
	
	float2 Tex = In.Tex;
	
	float3 N = 2.0f*tex2D( NormalSamp, Tex ).xyz-1.0;// @}bv̖@
	float3 R = reflect(-E, N);		// ˃xNg
	float amb = -vLightDir.w;						// ̋
	
    return In.Color * tex2D( DecaleSamp, Tex )	// gUƊɂ́A
			   * (max(0, dot(N, L))+amb)			// _FƃeNX`̐F
			 + 0.3f * pow(max(0,dot(R, L)), 8);		// Phong ʔˌ
}

// -------------------------------------------------------------
// eNjbN
// -------------------------------------------------------------
technique TShader
{
    pass P0
    {
        VertexShader = compile vs_1_1 VS();
        PixelShader  = compile ps_2_0 PS();
    }
    pass P1
    {
        VertexShader = compile vs_1_1 VS();
        PixelShader  = compile ps_2_0 PS_BUMP();
    }
}
